#!/usr/bin/env bash

SQLITE="sqlite3"

if [ $# == 0 ]
then
  echo
  echo "Naken Chat Password File Editor For SQLITE"
  echo "Copyright 2009 by Michael Kohn"
  echo "http://nakenchat.naken.cc/"
  echo "mike@mikekohn.net"
  echo
  echo "Usage: $0 <passwd file> <command> <options>"
  echo "          create"
  echo "          list"
  echo "          adduser <username> <password>"
  echo "          delete <username>"
  echo "          passwd <username> <passwd>"
  echo "          level <username> <level>"
  echo "          emote <username> <echochar>"
  echo "          channel <username> <default_channel>"
  echo "          flags <username> <default_flags>"
  echo
  exit
fi

case "$2" in
create) echo "Create password file"
  ${SQLITE} $1 "create table users ( username char(30) primary key, password char(30), emote char(1), level int, channel char(30), flags int )"
;;
adduser) echo "Add user to password file"
  ${SQLITE} $1 "insert into users values ('$3', '$4', '%', 0, '', 0)"
;;
list) echo "List users"
  ${SQLITE} $1 "select * from users"
;;
delete) echo "Delete user from password file"
  ${SQLITE} $1 "delete from users where username='$3'"
;;
passwd) echo "Change password in password file"
  ${SQLITE} $1 "update users set password='$4' where username='$3'"
;;
level) echo "Change default user level in password file"
  ${SQLITE} $1 "update users set level=$4 where username='$3'"
;;
emote) echo "Change default emote character"
  ${SQLITE} $1 "update users set emote='$4' where username='$3'"
;;
channel) echo "Change default channel for user"
  ${SQLITE} $1 "update users set channel='$4' where username='$3'"
;;
flags) echo "Change users flags"
  ${SQLITE} $1 "update users set flags=$4 where username='$3'"
;;
*)
  echo "Unknown command $2"
;;
esac

