#ifdef WINDOWS
#include <ws2tcpip.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#endif

/*  general.c   */
char *strcasestr(const char *hejstack, const char *needle);
void safestrncpy(char *dest, char *source, int n);
int socketdie(int socketid);
int logfile_on(int ID);
void leet(unsigned char *buf);
void destroy();
void broken_pipe();
void setsignals();
char *collapse(char *d, int c, char *old);
char *unban_number(int i);
int ban_address(char *addr);
int add_to_list(char *list, char *s, int list_len);
int search_list(char *list, char *s);
int get_num(char *s, int ID, int flags);
int strip(char *s);
void timediff(time_t time1, time_t time2, char *thisString);
void shorttimediff(time_t time1, time_t time2, char *thisString);
int channel(int ID, char *oName);
int conv_num(char *s);
void viewbans(int ID);
int is_number(char *myString);
unsigned int sql_esc(const char *s, char *r);

/* buffered_read.c */
int buffered_read(int ID);

/* chat_thread.c */
void chat();

/* info.c */
void channelinfo(int ID);
void clientshow(int ID);
void who(int ID, char *grep);
int write_whofile();
void who_short(int ID);
void show_levels(int ID);
void help(int ID);

/* message.c */
void message(int ID, char *text, int att);
void sendpriv(int ID_TO, int ID_FROM, char *text);
void sendchan(int ID, int channel, char *text);
void yell(int ID, char *text);
void sendchanbut(int ID, int channel, char *text);
void sendall(int ID, char *text);
void sendallbut(int ID, char *text);

/* nakenchat.c */
//static int init(int socketid, struct sockaddr_in *cli_addr, socklen_t clilen);
void kill_user(int ID);

/* user.c */
void update_list(int ID, int add);
int checkname_dup(char *name, int ID);


/* passwd_*.c */
int passwd_check(char *name, int ID);
int passwd_reg_name(int ID, char *password);

/* read_config.c */
void read_config();
// static void addtowelcome(char *s);
void setup(int argc, char *argv[]);


