
#ifndef INCLUDE_NAKEN_PLUGIN_H
#define INCLUDE_NAKEN_PLUGIN_H

#include "globals.h"
#include "naken_user.h"

typedef void (*message_t)(int ID, char *text, int hb_flag);
typedef void (*sendpriv_t)(int ID_TO, int ID_FROM, char *text);
typedef void (*sendchan_t)(int ID, int channel, char *text);
typedef void (*sendchanbut_t)(int ID, int channel, char *text);
typedef void (*sendall_t)(int ID, char *text);
typedef void (*sendallbut_t)(int ID, char *text);
typedef void (*kill_user_t)(int ID);

struct naken_context_t
{
  struct User **users;
  message_t message;         // Send message to user ID
  sendpriv_t sendpriv;       // Send private message to user from user
  sendchan_t sendchan;       // Send message to everyone in user ID's channel
  sendchanbut_t sendchanbut; // Send message to all in channel but user ID
  sendall_t sendall;         // Send to everyone on the chat
  sendallbut_t sendallbut;   // Send to everyone on chat but user ID
  kill_user_t kill_user;      // Kick user ID off the chat
};

#endif


