#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef NO_CRYPT_DOT_H
#include "crypt.h"
#endif

#include "language.h"
#include "globals.h"
#include "functions.h"

static int read_param(FILE *fp, char *s)
{
int ch;
int r;

  r=0;
  s[0]=0;

  while(1)
  {
    ch=getc(fp);
    if (ch==EOF && r==0) return -1;
    if ((ch=='\n' || ch=='\r') && r==0) continue;
    if (ch=='\\') { s[r++]=getc(fp); continue; }
    if (ch==':' || ch=='\n' || ch=='\r' || ch==EOF) break;
    s[r++]=ch;
  }

  s[r]=0;
  if (ch==':') return 1;

  return 0;
}

int passwd_check(char *name, int ID)
{
FILE *in;
char *p;
char param[1024];
char seed[3];
char crypted[20];
unsigned int l,t;
int i;

  in=fopen(passwd,"rb");
  if (in==0)
  {
#ifdef DEBUG
    if (debug==1) printf("Couldn't open password file.\n");
#endif
    passwd[0]=0;
    return 1;
  }

  l=strlen(name);
  t=l;
  while (name[l]!='=' && l>0) l--;
  if (l==0)
  {
    p=&name[t];
  }
    else
  {
    name[l]=0;
    p=&name[l+1];
  }

  while(1)
  {
    i=read_param(in,param);

    if (strcasecmp(param,name)==0)
    {
      if (ID==-1) return 1;

      read_param(in,param);
      seed[0]=param[0];
      seed[1]=param[1];
      seed[2]=0;
#ifndef NOCRYPT
      strcpy(crypted,crypt(p,seed));
#else
      strcpy(crypted,p);
#endif
      if (strcmp(crypted,param)!=0)
      { fclose(in); return 1; }

      read_param(in,param);
      users[ID]->user_level=atoi(param);
      read_param(in,param);
      users[ID]->emote_char=param[0];
      read_param(in,param);
      t=atoi(param);
      l=0xffffffff^(USER_BEEPS|USER_HILITES|USER_ECHOS);
      users[ID]->uflags=users[ID]->uflags&l;
      users[ID]->uflags=users[ID]->uflags|t;
      read_param(in,param);
      i=channel(ID,param);
      if (i>=0)
      {
        users[ID]->channel=i;
        users[ID]->uflags=users[ID]->uflags&65531;
      }

      fclose(in);
      return 0;
    }

    if (i==1)
    { while(read_param(in,param)); }
      else
    { break; }
  }

  fclose(in);

  return 2;
}

int passwd_reg_name(int ID, char *password)
{


  return -1;  // Not implemented
}


